#include "ClassPad.h"

#include "SH3Timers.h"

typedef unsigned char KEY_CODE;
extern "C" int GetKey(KEY_CODE code);

//////////////////////////////////////////////////////////////////

class Fenetre: public PegWindow
{
    public:
        Fenetre(PegRect rect):PegWindow(rect, FF_NONE),x(0),y(0),z(0)
        {   }
        
        int x,y,z;
        bool b_running;
        
        void Draw()
        {
            BeginDraw();
            DrawFrame();
            CPString str = cast_to_OBCD(x);
            PegColor col;
            DrawText(CPPoint(5,5), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetState(SH3TIMER_0));
            DrawText(CPPoint(5,15), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetTimerFreq(SH3TIMER_0));
            DrawText(CPPoint(5,25), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetClockFreq(SH3TIMER_0));
            DrawText(CPPoint(5,35), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetCount(SH3TIMER_0));
            DrawText(CPPoint(5,45), str.Text(), col, PegTextThing::GetBasicFont());

            str = cast_to_OBCD(y);
            DrawText(CPPoint(5+53,5), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetState(SH3TIMER_1));
            DrawText(CPPoint(5+53,15), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetTimerFreq(SH3TIMER_1));
            DrawText(CPPoint(5+53,25), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetClockFreq(SH3TIMER_1));
            DrawText(CPPoint(5+53,35), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetCount(SH3TIMER_1));
            DrawText(CPPoint(5+53,45), str.Text(), col, PegTextThing::GetBasicFont());
            
            str = cast_to_OBCD(z);
            DrawText(CPPoint(5+106,5), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetState(SH3TIMER_2));
            DrawText(CPPoint(5+106,15), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetTimerFreq(SH3TIMER_2));
            DrawText(CPPoint(5+106,25), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetClockFreq(SH3TIMER_2));
            DrawText(CPPoint(5+106,35), str.Text(), col, PegTextThing::GetBasicFont());
            str = cast_to_OBCD(SH3Timer_GetCount(SH3TIMER_2));
            DrawText(CPPoint(5+106,45), str.Text(), col, PegTextThing::GetBasicFont());
            if(b_running)
            {
                DrawText(CPPoint(20,150), "Appuyer sur EXE pour", col, PegTextThing::GetBasicFont());
                DrawText(CPPoint(30,160), "arreter la boucle", col, PegTextThing::GetBasicFont());
            }    
            EndDraw();
        }
        
        void Executer()
        {
            b_running = true;
            SH3Timer_StopAll();

            SH3Timer_SetClockFreq(SH3TIMER_0,SH3TIMER_CLKFRQ_230KHZ);
            SH3Timer_SetClockFreq(SH3TIMER_1,SH3TIMER_CLKFRQ_920KHZ);
            SH3Timer_SetClockFreq(SH3TIMER_2,SH3TIMER_CLKFRQ_3MHZ);
            SH3Timer_SetCount(SH3TIMER_0,CLKFRQ_230KHZ);
            SH3Timer_SetCount(SH3TIMER_1,CLKFRQ_920KHZ);
            SH3Timer_SetCount(SH3TIMER_2,CLKFRQ_3MHZ);
            SH3Timer_SetTimerFreq(SH3TIMER_0,CLKFRQ_230KHZ);
            SH3Timer_SetTimerFreq(SH3TIMER_1,CLKFRQ_920KHZ);
            SH3Timer_SetTimerFreq(SH3TIMER_2,CLKFRQ_3MHZ);

            while(1)
            {
                if(GetKey(0x21))            // lorsque "EXE" est enfonc
                    break;
                
                if(GetKey(0x31))            // lorsque "+" est enfonc
                    SH3Timer_StartAll();
                if(GetKey(0x41))            // lorsque "-" est enfonc
                    SH3Timer_StopAll();
                
                if(GetKey(0x35))            // lorsque "1" est enfonc
                    SH3Timer_Start(SH3TIMER_0);
                if(GetKey(0x34))            // lorsque "2" est enfonc
                    SH3Timer_Start(SH3TIMER_1);
                if(GetKey(0x32))            // lorsque "3" est enfonc
                    SH3Timer_Start(SH3TIMER_2);
                if(GetKey(0x45))            // lorsque "4" est enfonc
                    SH3Timer_Stop(SH3TIMER_0);
                if(GetKey(0x44))            // lorsque "5" est enfonc
                    SH3Timer_Stop(SH3TIMER_1);
                if(GetKey(0x42))            // lorsque "6" est enfonc
                    SH3Timer_Stop(SH3TIMER_2);
                
                if(SH3Timer_HasUnderflowed(SH3TIMER_0))
                    x++;
                if(SH3Timer_HasUnderflowed(SH3TIMER_1))
                    y++;
                if(SH3Timer_HasUnderflowed(SH3TIMER_2))
                    z++;
                Invalidate(mClient);
                Draw();
                
            }
            SH3Timer_StopAll();
            b_running = false;
        }    
};

void PegAppInitialize(PegPresentationManager *pPresentation)
{
	// create some simple Windows: 
	PegRect Rect;
	Rect.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);

	Fenetre *mw = new Fenetre(Rect);

	pPresentation->Add(mw);
	
	mw->Executer();
};


//////////////////////////////////////////////////////////////////

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
	return "";
}

//////////////////////////////////////////////////////////////////
